<?php

/**
 * Fusionforge Mailing Lists Facility
 *
 * Portions Copyright 1999-2001 (c) VA Linux Systems
 * The rest Copyright 2003-2004 (c) Guillaume Smet - Open Wide
 *
 * @version $Id$
 *
 * Portions Copyright 2010 (c) Mélanie Le Bail
 */

require_once '../../../env.inc.php';
require_once $gfcommon.'include/pre.php';
require_once $gfcommon.'preplugins.php';
require_once $gfcommon.'plugins_utils.php';
require_once '../mailman_utils.php';

$request =& HTTPRequest::instance();
$group_id=$request->get('group_id');
$group_list_id=$request->get('group_list_id');
$pm = ProjectManager::instance();
$Group = $pm->getProject($group_id);
$post_changes= $request->get('post_changes');
$add_list=$request->get('add_list');
$action=$request->get('action');
$change_status=$request->get('change_status');
$change_pw=$request->get('change_pw');
$list_name=$request->get('list_name');
$is_public=$request->get('is_public');
$is_moderate=$request->get('is_moderate');
$description=$request->get('description');
$PHP_SELF = $request->get('PHP_SELF');
//$feedback = '';


if ($group_id) {
	if (!$Group || !is_object($Group) || $Group->isError()) {

		exit_no_group();
	}

	session_require_perm ('project_admin', $Group->getID()) ;
	
	//
	//	RE-CREATE List with problems
	//
	if($action=='recreate') {
		$mailingList = new MailmanList($group_id, $group_list_id);
		if(!$mailingList || !is_object($mailingList)) {
			$error_msg = _('Error getting the list');
		} elseif($mailingList->isError()) {
			$error_msg = $mailingList->getErrorMessage();
		}
		$mailingList->recreate();
		$feedback .=_('List re-created');
		htmlRedirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&feedback='.urlencode($feedback));
	}

	//
	// SEND LIST PASSWORD to current user (if manager)
	//
	if ($action=='requestpw') {
		$mailingList = new MailmanList($group_id, $group_list_id);
		if(!$mailingList || !is_object($mailingList)) {
			$error_msg = _('Error getting the list');
		} elseif($mailingList->isError()) {
			$error_msg = $mailingList->getErrorMessage();
		}
		sendPasswordMail($mailingList);
		$feedback .=_('Password sent');
		htmlRedirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&feedback='.urlencode($feedback));
	}

	//
	//	Post Changes to database
	//
	if ($post_changes == 'y') {
		//
		//	Add list
		//
		if ($add_list == 'y') {
			$mailingList = new MailmanList($group_id);

			if(!$mailingList || !is_object($mailingList)) {
				$error_msg = _('Error getting the list');
			} elseif($mailingList->isError()) {
				$error_msg = $mailingList->getErrorMessage();
			}
				
			if ($is_public == 0) {
				if ($is_moderate == 0) {
					$is_public = MAIL__MAILING_LIST_IS_PRIVATE_NOT_MODERATE;
				} 
			} else {
				if ($is_moderate == 1) {
					$is_public = MAIL__MAILING_LIST_IS_PUBLIC_MODERATE;
				}
			}
			
			if(!$mailingList->create(
						$list_name,
						$description,
						$is_public
						)) {
				$error_msg = $mailingList->getErrorMessage();
			} else {
				$feedback .= _('List Added');
			}
			
			//
			//	Change status
			//
		} elseif ($change_status == 'y') {
			$mailingList = new MailmanList($group_id, $group_list_id);

			if(!$mailingList || !is_object($mailingList)) {
				$error_msg = _('Error getting the list');
			} elseif($mailingList->isError()) {
				$error_msg = $mailingList->getErrorMessage();
			}
		
			if ($is_public == 0) {
				if ($is_moderate == 0) {
					$is_public = MAIL__MAILING_LIST_IS_PRIVATE_NOT_MODERATE;
				} 
			} else {
				if ($is_moderate == 1) {
					$is_public = MAIL__MAILING_LIST_IS_PUBLIC_MODERATE;
				}
			}

			if(!$mailingList->update(
						$description,
						$is_public,
						$mailingList->getPassword()
						)) {

				$error_msg = $mailingList->getErrorMessage();
			} else {
				$feedback .= _('List updated');
			}
				
			//
			//	Add list with all members
			//
		} elseif ($add_list == 'p') {
			$mailingList = new MailmanList($group_id);

			if(!$mailingList || !is_object($mailingList)) {
				$error_msg = _('Error getting the list');
			} elseif($mailingList->isError()) {
				$error_msg = $mailingList->getErrorMessage();
			}
			
			if(!$mailingList->create(
						$list_name,
						_('All members of the project'),
						$is_public,
						false,
						true
						)) {
				$error_msg = $mailingList->getErrorMessage();
			} else {
				$feedback .= _('List Added');
			}
		} elseif ($change_pw == 'y') {
			$mailingList = new MailmanList($group_id, $group_list_id);

			if(!$mailingList || !is_object($mailingList)) {
				$error_msg = _('Error getting the list');
			} elseif($mailingList->isError()) {
				$error_msg = $mailingList->getErrorMessage();
			}
			
			if (!form_key_is_valid(getStringFromRequest('form_key'))) {
				exit_form_double_submit('my');
			}
		
			$old_passwd = getStringFromRequest('old_passwd');
			$passwd = getStringFromRequest('passwd');
			$passwd2 = getStringFromRequest('passwd2');
	
			if ($mailingList->getPassword() != $old_passwd) {
				form_release_key(getStringFromRequest('form_key'));
				$error_msg = _('Old password is incorrect');
				session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&group_list_id='.$group_list_id.'&action=managepw&error_msg='.urlencode($error_msg));
			}
		
			if (strlen($passwd)<6) {
				form_release_key(getStringFromRequest('form_key'));
				$error_msg = _('You must supply valid password (at least 6 chars)');
				session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&group_list_id='.$group_list_id.'&action=managepw&error_msg='.urlencode($error_msg));
			}
		
			if ($passwd != $passwd2) {
				form_release_key(getStringFromRequest('form_key'));
				$error_msg = _('New passwords do not match.');
				session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&group_list_id='.$group_list_id.'&action=managepw&error_msg='.urlencode($error_msg));
			}
		
			if (!$mailingList->update($mailingList->getDescription(), $mailingList->isPublic(), $passwd)) {
				form_release_key(getStringFromRequest('form_key'));
				$error_msg = _('Could not change password: ').$mailingList->getErrorMessage();
				session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&group_list_id='.$group_list_id.'&action=managepw&error_msg='.urlencode($error_msg));
			}

			$feedback .= _('Password updated');

		}
	}

	//
	//	Form to add list
	//
	if($add_list == 1) {
		//
		//	Form to add list
		//
		mailman_header(array(
					'title' => _('Add a Mailing List'),
					'help'=>'CommunicationServices.html#MailingLists',
					'admin' => '1'));
		echo '<p>';
		printf(_('Lists are named in this manner:<br /><strong>projectname-listname@%1$s</strong>'), forge_get_config('lists_domain'));
		print '</p>';

		print '<p>';
		print _('It will take up to <span class="important">6 hours</span> for your list to be created.');
		echo '</p>';

		$mlFactory = new MailmanListFactory($Group);
		if (!$mlFactory || !is_object($mlFactory) || $mlFactory->isError()) {
			$error_msg = $mlFactory->getErrorMessage();
		}

		$mlArray =& $mlFactory->getMailmanLists();

		if ($mlFactory->isError()) {
			echo '<h1>'._('Error').' '._('Unable to get the lists') .'</h1>';
			echo $mlFactory->getErrorMessage();
			mail_footer(array());
			exit;
		}
			$tableHeaders = array(
			_('Existing mailing lists')
		);
		//
		//	Show lists
		//
		$mlCount = count($mlArray);
		if($mlCount > 0) {
			echo $HTML->listTableTop($tableHeaders);
			for ($j = 0; $j < $mlCount; $j++) {
				$currentList =& $mlArray[$j];
				if ($currentList->isError()) {
					echo '<tr '. $HTML->boxGetAltRowStyle($j) . '><td>';
					echo $currentList->getErrorMessage();
					echo '</td></tr>';
				} else {
					echo '<tr '. $HTML->boxGetAltRowStyle($j) . '><td>'.$currentList->getName().'</td></tr>';
				}
			}
			echo $HTML->listTableBottom();
		}
		?>
		<form method="post" action="<?php echo $PHP_SELF; ?>?group_id=<?php echo $group_id ?>">
		<input type="hidden" name="post_changes" value="y" />
		<input type="hidden" name="add_list" value="y" />
		<p><strong><?php echo _('Mailing List Name:'); ?></strong><br />
		<strong><?php echo $Group->getUnixName(); ?>-<input type="text" name="list_name" value="" size="10" maxlength="12" />@<?php echo forge_get_config('lists_domain'); ?></strong><br /></p>
		<p>
		<strong><?php echo _('Is Public?'); ?></strong><br />
		<input type="radio" name="is_public" value="1" checked="checked" /> <?php echo _('Yes'); ?><br />
		<input type="radio" name="is_public" value="0" /> <?php echo _('No'); ?></p><p>
		<strong><?php echo _('Approve Subscriptions?'); ?></strong><br />
		<input type="radio" name="is_moderate" value="1" checked="checked" /> <?php echo _('Yes'); ?><br />
		<input type="radio" name="is_moderate" value="0" /> <?php echo _('No'); ?></p><p>
		<strong><?php echo _('Description:'); ?></strong><br />
		<input type="text" name="description" value="" size="40" maxlength="80" /><br /></p>
		<p>
		<input type="submit" name="submit" value="<?php echo _('Add This List'); ?>" /></p>
		</form>
		<?php
		mail_footer(array());
			
	} elseif ($add_list == 2) {
		//
		//	Form to add list with all members
		//
		mailman_header(array(
					'title' => _('Create a Mailing List with all members'),
					'help'=>'CommunicationServices.html#MailingLists',
					'admin' => '1'));

		print '<p>';
		print _('It will take up to <span class="important">6 hours</span> for your list to be created.');
		echo '</p>';

		?>
		<form method="post" action="<?php echo $PHP_SELF; ?>?group_id=<?php echo $group_id ?>">
		<input type="hidden" name="post_changes" value="y" />
		<input type="hidden" name="add_list" value="p" /><p>
		<strong><?php echo _('Mailing List Name:'); ?></strong><br />
		<strong><?php echo $Group->getUnixName(); ?>@<?php echo forge_get_config('lists_domain'); ?></strong><br /></p>		
		<p>
		<strong><?php echo _('Is Public?'); ?></strong><br />
		<input type="radio" name="is_public" value="1" checked="checked" /> <?php echo _('Yes'); ?><br />
		<input type="radio" name="is_public" value="0" /> <?php echo _('No'); ?></p>
		<p>
		<input type="submit" name="submit" value="<?php echo _('Add This List'); ?>" /></p>
		</form>
		<?php
		mail_footer(array());
				
	} elseif ($change_status == 1 && $group_list_id) {
		//
		//	Form to modify list
		//
		$mailingList = new MailmanList($group_id, $group_list_id);
		if(!$mailingList || !is_object($mailingList)) {
			$error_msg = _('Error getting the list');
		} elseif($mailingList->isError()) {
			$error_msg = $mailingList->getErrorMessage();
		}
		mailman_header(array(
					'title' => _('Mail admin'),
					'help'=>'CommunicationServices.html#MailingLists',
					'admin' => 1));
		?>

		<h3><?php echo $mailingList->getName(); ?></h3>
		<form method="post" action="<?php echo $PHP_SELF; ?>?group_id=<?php echo $group_id; ?>&amp;group_list_id=<?php echo $mailingList->getID(); ?>">
		<input type="hidden" name="post_changes" value="y" />
		<input type="hidden" name="change_status" value="y" />
		<p>
		<strong><?php echo _('Is Public?'); ?></strong><br />
		<input type="radio" name="is_public" value="1"<?php echo ($mailingList->isPublic() == MAIL__MAILING_LIST_IS_PUBLIC || $mailingList->isPublic() == MAIL__MAILING_LIST_IS_PUBLIC_MODERATE ? ' checked="checked"' : ''); ?> /> <?php echo _('Yes'); ?><br />
		<input type="radio" name="is_public" value="0"<?php echo ($mailingList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE || $mailingList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE_NOT_MODERATE ? ' checked="checked"' : ''); ?> /> <?php echo _('No'); ?><br />
		</p>
		<?php 
		if (strCmp($mailingList->getName(),$mailingList->Group->getUnixName()) <> 0) {
		?>
			<p>
			<strong><?php echo _('Approve Subscriptions?'); ?></strong><br />
			<input type="radio" name="is_moderate" value="1"<?php echo ($mailingList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE || $mailingList->isPublic() == MAIL__MAILING_LIST_IS_PUBLIC_MODERATE ? ' checked="checked"' : ''); ?> /> <?php echo _('Yes'); ?><br />
			<input type="radio" name="is_moderate" value="0"<?php echo ($mailingList->isPublic() == MAIL__MAILING_LIST_IS_PUBLIC || $mailingList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE_NOT_MODERATE ? ' checked="checked"' : ''); ?> /> <?php echo _('No'); ?><br />
			</p>
		<?php
		}
		?>
		<p><strong><?php echo _('Description:'); ?></strong><br />
		<input type="text" name="description" value="<?php echo $mailingList->getDescription(); ?>" size="40" maxlength="80" /><br /></p>
		<p>
		<input type="submit" name="submit" value="<?php echo _('Update'); ?>" /></p>
		</form>
		<?php
		mail_footer(array());

	} else if ($action == 'managepw' && $group_list_id) {
		//
		// Manage list administration password
		//
	
		$mailingList = new MailmanList($group_id, $group_list_id);
		if(!$mailingList || !is_object($mailingList)) {
			$error_msg = _('Error getting the list');
		} elseif($mailingList->isError()) {
			$error_msg = $mailingList->getErrorMessage();
		}
		
		mailman_header(array(
					'title' => _('Manage administration password for ').$mailingList->getName(),
					'help'=>'CommunicationServices.html#MailingLists',
					'admin'=>1)
			      );
		
		echo '<ul>
			<li>
			<a href="'.$PHP_SELF.'?group_id='.$group_id.'&amp;action=changepw&amp;group_list_id='.$mailingList->getID().'">'._('Change administration password').'</a>
			</li>
			</ul>';
		echo '<ul>
			<li>
			<a href="'.$PHP_SELF.'?group_id='.$group_id.'&amp;action=requestpw&amp;group_list_id='.$mailingList->getID().'">'._('Send password').'</a>
			</li>
			</ul>';
		
		mail_footer(array());
		
	} else if ($action == 'changepw' && $group_list_id) {		
		//
		// Change administration password
		//
		
			$mailingList = new MailmanList($group_id, $group_list_id);
		if(!$mailingList || !is_object($mailingList)) {
			$error_msg = _('Error getting the list');
		} elseif($mailingList->isError()) {
			$error_msg = $mailingList->getErrorMessage();
		}	
			
		mailman_header(array(
					'title' => _('Change administration password for ').$mailingList->getName(),
					'help'=>'CommunicationServices.html#MailingLists',
					'admin'=>1)
			      );

		print '<p>';
		print _('It will take up to <span class="important">6 hours</span> for your list to be updated.');
		echo '</p>';
			      
		?>
		<form method="post" action="<?php echo $PHP_SELF; ?>?group_id=<?php echo $group_id; ?>&amp;group_list_id=<?php echo $mailingList->getID(); ?>">
		<input type="hidden" name="post_changes" value="y" />
		<input type="hidden" name="change_pw" value="y" />
		<input type="hidden" name="form_key" value="<?php echo form_generate_key(); ?>"/>
		<p><?php echo _('Old Password') ?>:
		<br /><input type="password" name="old_passwd" /></p>
		<p><?php echo _('New Password (at least 6 chars)') ?>:
		<br /><input type="password" name="passwd" /></p>
		<p><?php echo _('New Password (repeat)') ?>:
		<br /><input type="password" name="passwd2" /></p>
		<p><input type="submit" name="submit" value="<?php echo _('Update password') ?>" /></p>
		</form>
		<?php
		
		mail_footer(array());
			
	} else {
		//
		//	Show lists
		//
		$mlFactory = new MailmanListFactory($Group);
		if (!$mlFactory || !is_object($mlFactory) || $mlFactory->isError()) {
			$error_msg = $mlFactory->getErrorMessage();
		}

		mailman_header(array(
					'title' => _('Mailing List Administration'),
					'help'=>'CommunicationServices.html#MailingLists',
					'admin'=>1)
			      );

		$mlArray =& $mlFactory->getMailmanLists();

		if ($mlFactory->isError()) {
			echo '<p>'._('Error').' '.sprintf(_('Unable to get the list %s'), $Group->getPublicName()) .'</p>';
			echo $mlFactory->getErrorMessage();
			mail_footer(array());
			exit;
		}
		echo '<p>'.sprintf(_('You can administrate lists from here. Please note that private lists can still be viewed by members of your project, but are not listed on %1$s.'), forge_get_config ('forge_name')).'</p>';
		echo '<ul>
			<li>
			<a href="'.$PHP_SELF.'?group_id='.$group_id.'&amp;add_list=1">'._('Add Mailing List').'</a>
			</li>
			</ul>';
		echo '<ul>
			<li>
			<a href="'.$PHP_SELF.'?group_id='.$group_id.'&amp;add_list=2">'._('Create a Mailing List with all members').'</a>
			</li>
			</ul>';
		$mlCount = count($mlArray);

		if($mlCount > 0) {
			table_begin_admin();
			$private = 0;
			for ($j = 0; $j < $mlCount; $j++) {

				$currentList =& $mlArray[$j];
				display_list_admin($currentList);
				if ($currentList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE || $currentList->isPublic() == MAIL__MAILING_LIST_IS_PRIVATE_NOT_MODERATE) {
					$private++;
				}
			}

			table_end($private);
			
			// 
			// Admin the list with the external tools used
			//
			if ($action=='admin') {
				$mailingList = new MailmanList($group_id, $group_list_id);
				if(!$mailingList || !is_object($mailingList)) {
					$error_msg = _('Error getting the list');
				} elseif($mailingList->isError()) {
					$error_msg = $mailingList->getErrorMessage();
				}
				$mailingList->getExternalAdminUrl();
			}
				
		}
		mail_footer(array());
	}
} else {
        exit_no_group();
}
?>
