<?php
/**
 * Delete Users Page
 *
 * Copyright 2004 (c) Tim Perdue - GForge LLC
 * Copyright 2010 (c) Franck Villaume - Capgemini
 * http://fusionforge.org
 *
 * This file is part of FusionForge. FusionForge is free software;
 * you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the Licence, or (at your option)
 * any later version.
 *
 * FusionForge is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with FusionForge; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

require_once('../../env.inc.php');
require_once $gfcommon.'include/pre.php';
require_once $gfcommon.'preplugins.php';
require_once 'mailman_utils.php';

$request =& HTTPRequest::instance();
$group_id = $request->get('group_id');
$group_list_id = $request->get('group_list_id');
$admin = $request->get('admin');

session_require_perm ('project_admin', $group_id) ;

$group = group_get_object($group_id);
if (!$group || !is_object($group)) {
    exit_no_group();
} elseif ($group->isError()) {
	exit_error($group->getErrorMessage(),'admin');
}

$ml = new MailmanList($group_id,$group_list_id);

if(!$ml || !is_object($ml)) {
	$error_msg = _('Error getting the list');
	session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&error_msg='.urlencode($error_msg));
} elseif($ml->isError()) {
	$error_msg = $ml->getErrorMessage();
	session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id.'&error_msg='.urlencode($error_msg));
} else {	
	$listname = $ml->getName();
}

$res = db_query_params('SELECT name,address FROM plugin_mailman WHERE listname=$1 AND hide=\'N\' ORDER BY name, address',
		       array($listname));

if (getStringFromRequest('finished')) {
	if ($admin) {
		Session_redirect('/plugins/mailman/admin/index.php?group_id='.$group_id);
	} else {
		Session_redirect('/plugins/mailman/index.php?group_id='.$group_id);
	}
}

mailman_header(array(
'title' => _('Members of the list').' '.$listname,
				'help'=>'CommunicationServices.html#MailingLists',
				'admin'=>1)
);

echo '
<form action="'.getStringFromServer('PHP_SELF').'?group_id='.$group_id.'&group_list_id='.$group_list_id.'" method="post">';
if ($admin) {
	echo '<input type="hidden" name="admin" value="1" />';
}

if (!$res || db_numrows($res) < 1) {
	echo _('No Matching Users Found');
} else {

	$titles[]=_('Real name');
	$titles[]=_('Email');

	echo $HTML->listTableTop($titles);

	for ($i=0; $i<db_numrows($res); $i++) {

		$email = db_result($res,$i,'address');
		echo '<tr '. $HTML->boxGetAltRowStyle($i) . '>
			<td>'.db_result($res,$i,'name').'</td>
			<td>'.$email.'</td></tr>';

	}

	echo $HTML->listTableBottom();

}

echo '<p><input type="submit" name="finished" value="'._('Return').'" /></p>
</form>';

mail_footer(array());

// Local Variables:
// mode: php
// c-file-style: "bsd"
// End:

?>
